from typing import Any, Literal
from pydantic import BaseModel


class DevcachedSentryConfig(BaseModel):
    # Sentry DSN
    dsn: str


class DevcachedConfig(BaseModel):
    # The path to where data should be stored
    data: str

    # Base URL of the service
    base_url: str

    # List of modules to load
    modules: dict[str, Any]

    # Log level
    logging: Literal["debug"] | Literal["info"] = "info"

    # Optional Sentry config
    sentry: DevcachedSentryConfig | None = None
