from typing import Callable
from pathlib import Path

import requests


def find[T](list_: list[T], pred: Callable[[T], bool]) -> T | None:
    for i in list_:
        if pred(i):
            return i
    return None


def file_iterator(file: Path):
    with file.open("rb") as f:
        yield from f


def download_binary_file(dest: Path, url: str):
    with requests.get(url, stream=True) as r:
        with open(dest, "wb") as f:
            for chunk in r.iter_content(chunk_size=8196):
                f.write(chunk)
